;
; IDL Event Callback Procedures
; MSP_EB_Detector_eventcb
;
; Generated on:	08/29/2016 14:19.43
;
;
; Empty stub procedure used for autoloading.
;
pro MSP_EB_Detector_eventcb
end
;------------------------------------------
pro MSP_EB_PostCreation, wWidget, _EXTRA=_VWBExtra_
  ;
	;
	;	and directory from which the software was launched
	;
	CD, CURRENT=this_dir
	;
	;	set up and clear summary structure
	;
	summary_struct = {	analysis_dir:			'',			$	root of directory structure
						last_dir:			'none',			$   last raw data directory accessed
						lu_log:					0L,			$	lu of log file
						log_path:				'',			$ 	pathname to the log file
						this_dir:			this_dir,		$	launch directory
						paths:			strarr(5000),		$
						npaths:					0L,			$
						classifications: strarr(5000) 		$
						;
					  }
	;

	;
	widget_struct = {	    History_textbox_wid:	 			0L,	$
							Exit_button_wid: 					0L,	$
							;
							Term_1_textbox_wid: 				0L,	$
							Term_1_label_wid:					0L, $
							Term_2_textbox_wid: 				0L,	$
							Term_2_label_wid:					0L, $
							Term_3_textbox_wid: 				0L,	$
							Term_3_label_wid:					0L, $
							Term_4_textbox_wid:					0L, $
							Term_4_label_wid:					0L, $
							Term_5_textbox_wid:					0L, $
							Term_5_label_wid:					0L, $
							Term_6_textbox_wid:					0L, $
							Term_6_label_wid:					0L, $
							Term_7_textbox_wid:					0L, $
							Term_7_label_wid:					0L, $
							Term_8_textbox_wid:					0L, $	; expansion
							Term_8_label_wid:					0L, $
							Term_9_textbox_wid:					0L, $
							Term_9_label_wid:					0L, $
								Term_textbox_nch: 		 lonarr(9), $
								Term_textbox_buffer:    strarr(9,72),$
								Term_textbox_value:		fltarr(9), $
							;
							Plot_UL_wid:						0L, $
							Plot_UR_wid:						0L, $
							Plot_LL_wid:						0L, $
							Plot_LR_wid:						0L, $
							Plot_BT_wid:						0L, $
							Plot_BB_wid:						0L, $
							Plot_Main_wid:						0L, $
							Plot_Window:				lonarr(7),  $
							;
							Classification_draw_window_wid:     0L, $
							Classification_label_wid:			0L, $
							;
							Plot_wait_checkbox_wid:				0L, $
							Plot_wait_checkbox_value:			0L, $
							;
							Launch_file_chooser_button_wid:		0L, $
							Start_testing_button_wid:			0L $


						}
	;
	;	step-specific structures
	;

	PTR_summary = PTR_NEW(summary_struct,/NO_COPY)
	PTR_wid = PTR_NEW(widget_struct,/NO_COPY)
    ;
    ;	load the pointer(s) into the pointer structure
    ;
    PTR_struct = {PTR_summary: PTR_summary, PTR_wid: PTR_wid}
    ;
    WIDGET_CONTROL, wWidget, SET_UVALUE=PTR_struct
end

;-----------------------------------------------------------------
pro MSP_EB_Exit, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct	;	close log file
	s_ptr = PTR_struct.PTR_summary
	w_ptr = PTR_struct.PTR_wid
	;
	;free the pointers
	;
	;	and then the full structure pointers
	;
	PTR_FREE, w_ptr
	PTR_FREE, s_ptr
	;
	WIDGET_CONTROL, Event.top, /DESTROY
end
;
;-----------------------------------------------------------------
pro MSP_EB_Realize, wWidget
	WIDGET_CONTROL, wWidget, GET_UVALUE=PTR_struct
	;
	;	load all the widget IDs
	;
	;	need to pass an event structure:
	;
	event = {top: wWidget}
	get_wids, event
	;
	;	reread the pointer structure to get updated wids
	;
	WIDGET_CONTROL, wWidget, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	;
	w_ptr = PTR_struct.PTR_wid
	;
	print_text, event, "Mimir Software Package: E&B Finder - Initialized!"
	;
	;	write message to each plot window
	;
	WIDGET_CONTROL, (*w_ptr).Plot_UL_wid, GET_VALUE=win_UL
	wset, win_UL
	erase
	plot, [0,1],[0,1],xstyle=5,ystyle=5,/nodata
	xyouts, 0.5, 0.5, 'UL Window',alignment=0.5
	(*w_ptr).Plot_Window[0] = win_UL
	;
	WIDGET_CONTROL, (*w_ptr).Plot_UR_wid, GET_VALUE=win_UR
	wset, win_UR
	erase
	plot, [0,1],[0,1],xstyle=5,ystyle=5,/nodata
	xyouts, 0.5, 0.5, 'UR Window',alignment=0.5
	(*w_ptr).Plot_Window[1] = win_UR
	;
	WIDGET_CONTROL, (*w_ptr).Plot_LL_wid, GET_VALUE=win_LL
	wset, win_LL
	erase
	plot, [0,1],[0,1],xstyle=5,ystyle=5,/nodata
	xyouts, 0.5, 0.5, 'LL Window',alignment=0.5
	(*w_ptr).Plot_Window[2] = win_LL
	;
	WIDGET_CONTROL, (*w_ptr).Plot_LR_wid, GET_VALUE=win_LR
	wset, win_LR
	erase
	plot, [0,1],[0,1],xstyle=5,ystyle=5,/nodata
	xyouts, 0.5, 0.5, 'LR Window',alignment=0.5
	(*w_ptr).Plot_Window[3] = win_LR
	;
	WIDGET_CONTROL, (*w_ptr).Plot_BT_wid, GET_VALUE=win_BT
	wset, win_BT
	erase
	plot, [0,1],[0,1],xstyle=5,ystyle=5,/nodata
	xyouts, 0.5, 0.5, 'BT Window',alignment=0.5
	(*w_ptr).Plot_Window[4] = win_BT
	;
	WIDGET_CONTROL, (*w_ptr).Plot_BB_wid, GET_VALUE=win_BB
	wset, win_BB
	erase
	plot, [0,1],[0,1],xstyle=5,ystyle=5,/nodata
	xyouts, 0.5, 0.5, 'BB Window',alignment=0.5
	(*w_ptr).Plot_Window[5] = win_BB
	;
	WIDGET_CONTROL, (*w_ptr).Plot_Main_wid, GET_VALUE=win_Main
	wset, win_Main
	erase
	plot, [0,1],[0,1],xstyle=5,ystyle=5,/nodata
	xyouts, 0.5, 0.5, 'Main Window',alignment=0.5
	(*w_ptr).Plot_Window[6] = win_Main
	;
	;	and load the term text windows
	;
	WIDGET_CONTROL, (*w_ptr).Term_1_label_wid, SET_VALUE='stars have sPA LE value [deg] '
	WIDGET_CONTROL, (*w_ptr).Term_1_textbox_wid, SET_VALUE='15.0'
	(*w_ptr).Term_textbox_nch[0] = 4
;	(*w_ptr).Term_textbox_buffer[0,*] = '15.0'
	(*w_ptr).Term_textbox_value[0] = 15.0
	;
	WIDGET_CONTROL, (*w_ptr).Term_2_label_wid, SET_VALUE='PA_start'
	WIDGET_CONTROL, (*w_ptr).Term_2_textbox_wid, SET_VALUE='-180.0'
	(*w_ptr).Term_textbox_nch[1] = 6
;	(*w_ptr).Term_textbox_buffer[1,*] = '-180.0'
	(*w_ptr).Term_textbox_value[1] = -180.0
	;
	WIDGET_CONTROL, (*w_ptr).Term_3_label_wid, SET_VALUE='PA_end'
	WIDGET_CONTROL, (*w_ptr).Term_3_textbox_wid, SET_VALUE='360.0'
	(*w_ptr).Term_textbox_nch[2] = 5
;	(*w_ptr).Term_textbox_buffer[2,*] = '360.0'
	(*w_ptr).Term_textbox_value[2] = 360.0
	;
	WIDGET_CONTROL, (*w_ptr).Term_4_label_wid, SET_VALUE='dPA_step'
	WIDGET_CONTROL, (*w_ptr).Term_4_textbox_wid, SET_VALUE='10.0'
	(*w_ptr).Term_textbox_nch[3] = 4
;	(*w_ptr).Term_textbox_buffer[3,*] = '10.0'
	(*w_ptr).Term_textbox_value[3] = 10.0
	;
	WIDGET_CONTROL, (*w_ptr).Term_5_label_wid, SET_VALUE='pixels per P[%]'
	WIDGET_CONTROL, (*w_ptr).Term_5_textbox_wid, SET_VALUE='5.0'
	(*w_ptr).Term_textbox_nch[4] = 3
;	(*w_ptr).Term_textbox_buffer[4,*] = '5.0'
	(*w_ptr).Term_textbox_value[4] = 5.0
	;
	WIDGET_CONTROL, (*w_ptr).Term_6_label_wid, SET_VALUE='Rad(inner) [px]'
	WIDGET_CONTROL, (*w_ptr).Term_6_textbox_wid, SET_VALUE='200.0'
	(*w_ptr).Term_textbox_nch[5] = 5
;	(*w_ptr).Term_textbox_buffer[5,*] = '200.0'
	(*w_ptr).Term_textbox_value[5] = 200.0
	;
	WIDGET_CONTROL, (*w_ptr).Term_7_label_wid, SET_VALUE='Max Mag.'
	WIDGET_CONTROL, (*w_ptr).Term_7_textbox_wid, SET_VALUE='13.0'
	(*w_ptr).Term_textbox_nch[6] = 4
;	(*w_ptr).Term_textbox_buffer[6,*] = '13.0'
	(*w_ptr).Term_textbox_value[6] = 13.0
	;
	;	clear classification windows to gray
	;
	WIDGET_CONTROL, (*w_ptr).Classification_label_wid, SET_VALUE='Not Tested'
	colors = ['gray','gray','gray','gray','gray','gray','gray','gray']
	EB_led_stack, (*w_ptr).Classification_draw_window_wid, colors
	;
	colors = ['gray']
	EB_led_stack, (*w_ptr).Plot_BB_wid, colors
end
;
;-----------------------------------------------------------------------
pro Launch_File_Chooser, Event
	;
	;	puts up a file chooser to select POLCATS, returns list and number
	;	of entries into structure
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	w_ptr = PTR_struct.PTR_wid
	;
	restart:
	if( (*s_ptr).last_dir eq 'none') then begin
		files = dialog_pickfile(title='Select one or more POLCATS',/multiple)
	endif else begin
		files = dialog_pickfile(title='Select one or more POLCATS',/multiple,PATH=(*s_ptr).last_dir+PATH_SEP()+'junk.dat')
	endelse
	;
	;
	nf = N_ELEMENTS(files)
	if(nf eq 0) then begin
		print_text, Event, 'Error - no files selected. Try again.'
		goto, restart
	endif
	;
	(*s_ptr).npaths = nf
	(*s_ptr).paths[0:nf-1] = files[*]
	;
	print_text, Event, 'Selected '+STRING(nf,format='(I)')+' POLCATS'
	;
	;	save the directory
	;
	(*s_ptr).last_dir = FILE_DIRNAME(files[0])
	;
end
;----------------------------------------------------------------
;
pro Show_Textboxes, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_Struct
	s_ptr = PTR_Struct.PTR_summary
	w_ptr = PTR_Struct.PTR_wid
	;
	;	for each Term window, put the value of the buffer into it
	for ibox = 0, 6 do begin
		case ibox of
			0: wid = (*w_ptr).Term_1_textbox_wid
			1: wid = (*w_ptr).Term_2_textbox_wid
			2: wid = (*w_ptr).Term_3_textbox_wid
			3: wid = (*w_ptr).Term_4_textbox_wid
			4: wid = (*w_ptr).Term_5_textbox_wid
			5: wid = (*w_ptr).Term_6_textbox_wid
			6: wid = (*w_ptr).Term_7_textbox_wid
;			7: wid = (*w_ptr).Term_8_textbox_wid
;			8: wid = (*w_ptr).Term_9_textbox_wid
		endcase
		;
		WIDGET_CONTROL, wid, SET_VALUE=STRING(format='(F8.1)',(*w_ptr).Term_textbox_value[ibox])
	endfor
end
;
;---------------------------------------------------------------
function Modify_Term1, Event
	Modify_Term, Event, 0
	return, Event
end
;
function Modify_Term2, Event
	Modify_Term, Event, 1
	return, Event
end
;
function Modify_Term3, Event
	Modify_Term, Event, 2
	return, Event
end
;
function Modify_Term4, Event
	Modify_Term, Event, 3
	return, Event
end
;
function Modify_Term5, Event
	Modify_Term, Event, 4
	return, Event
end
;
function Modify_Term6, Event
	Modify_Term, Event, 5
	return, Event
end
;
function Modify_Term7, Event
	Modify_Term, Event, 6
	return, Event
end
;
function Modify_Term8, Event
	Modify_Term, Event, 7
	return, Event
end
;
function Modify_Term9, Event
	Modify_Term, Event, 8
	return, Event
end
;
function Modify_Term10, Event
	Modify_Term, Event, 9
	return, Event
end
;-----------------------------------------------------------------
pro Toggle_Plot_Wait_Checkbox, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_Struct
	w_ptr = PTR_Struct.PTR_wid
	;
	;	toggles the checkbox and resets the value
	;
	(*w_ptr).Plot_wait_checkbox_value = 1L - (*w_ptr).Plot_wait_checkbox_value
	WIDGET_CONTROL, (*w_ptr).Plot_wait_checkbox_wid, SET_BUTTON=(*w_ptr).Plot_wait_checkbox_value
	print_text, Event, 'Toggled Plot Wait Checkbox Value'
	;
end
;
;------------------------------------------------------------------
pro	Modify_Term, Event, ibox
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_Struct
	s_ptr = PTR_Struct.PTR_summary
	w_ptr = PTR_Struct.PTR_wid
	;
	case ibox of
		0: wid = (*w_ptr).Term_1_textbox_wid
		1: wid = (*w_ptr).Term_2_textbox_wid
		2: wid = (*w_ptr).Term_3_textbox_wid
		3: wid = (*w_ptr).Term_4_textbox_wid
		4: wid = (*w_ptr).Term_5_textbox_wid
		5: wid = (*w_ptr).Term_6_textbox_wid
		6: wid = (*w_ptr).Term_7_textbox_wid
	endcase
	;
;	print_text, Event, 'in Modify_Term, ibox, wid, Event.type = '+STRING(ibox,wid,Event.type,$
;					format='(I2,1x,I3,1x,I3)')
	;
	;	first, fetch current pointer into text box buffer
	;
	nch = (*w_ptr).Term_textbox_nch[ibox]
	;
	new_name = 0
	;
	if(Event.type eq 0) then begin
		;
		;	if character not CR, put it into buffer
		;
		ch = Event.ch
		if(ch ne 10B) then begin
			WIDGET_CONTROL, wid, GET_VALUE=existing_text
			(*w_ptr).Term_textbox_nch[ibox] = STRLEN(existing_text)
			for il = 0, STRLEN(existing_text[0])-1 do (*w_ptr).Term_textbox_buffer[ibox,il] = STRMID(existing_text, il, 1)
			WIDGET_CONTROL, wid, SET_TEXT_SELECT=[Event.offset,0]
			;
		endif else begin
			;
			;	was a character return - load the buffer into a single string
			;
			name = ''
			for ich = 0, (*w_ptr).Term_textbox_nch[ibox]-1 do begin
				name = name + (*w_ptr).Term_textbox_buffer[ibox,ich]
			endfor
			name = STRTRIM(name,2)
			;
			;	new name available - put it into current buffer and issue a relist command
			;
			new_name = 1
			;
		endelse
		;
		;print_text, Event, "Insert Character Event - Character = "+STRING(format='(a)',Event.ch)
	endif else begin
		if(Event.type eq 1) then begin
			WIDGET_CONTROL, wid, GET_VALUE=existing_text
			name = STRTRIM(Event.str,2)
			length = STRLEN(name)
			if(length gt 1) then begin
				this_name = strarr(length)
				for il=0, length-1 do begin
					this_name[il] = STRMID(name,il,1)
				endfor
			endif else begin
				if(length eq 0) then goto, MT_end
				;
				this_name = strarr(1)
				this_name[0] = name
			endelse
			new_name = 1
			;
		endif else begin
			if(Event.type eq 2) then begin							; delete
				WIDGET_CONTROL, wid, GET_VALUE=existing_text
				;
				;	if length = 0 just skip
				;
				if(Event.length eq 0) then goto, MT_end
				;

			endif else begin
				if(Event.type eq 3) then begin
;					print_text, Event, 'Text selected'
					goto, MT_end
				endif else begin
					print_text, Event, 'Event type = '+STRING(Event.type,format='(I)')
					;
					a = 0
					;
				endelse
			endelse
		endelse
		(*w_ptr).Term_textbox_nch[ibox] = STRLEN(existing_text)
		for il = 0, STRLEN(existing_text[0])-1 do (*w_ptr).Term_textbox_buffer[ibox,il] = STRMID(existing_text, il, 1)
		WIDGET_CONTROL, wid, SET_TEXT_SELECT=[Event.offset,0]
	endelse
	;
	if(new_name eq 1) then begin
		;
		;	replace old value with new, but only accept good floating point value
		;
		CATCH, ibad
		;
		if(ibad ne 0) then begin
			print_text, Event, "Bad input, try again"
			;
			;	clear buffer to old values
			;
			(*w_ptr).Term_textbox_nch[ibox] = 0
			(*w_ptr).Term_textbox_buffer[ibox,*] = ''
			;
			;	and reshow
			;
			Show_Textboxes, Event
			;
			CATCH, /CANCEL
			;
			goto, MT_end
		endif
		;
		reads, name, format='(F)', value
		;
		print_text, Event, "Replacing value with "+STRING(format='(F)',value)
		;
		(*w_ptr).Term_textbox_value[ibox] = value
		;
		Show_Textboxes, Event
		;
		;	clear buffer
		;
		(*w_ptr).Term_textbox_nch[ibox] = 0
		(*w_ptr).Term_textbox_buffer[ibox,*] = ''
		;
		CATCH, /CANCEL
	endif
	;
	MT_end:
	;
end
;
;---------------------------------------------------------------------------
;
pro Test_POLCATS, Event
	;
	;	analyzes a single GPIPS POLCAT file to search for excess E and B mode signals
	;	(which likely identify GPIPS fields with data reduction problems).
	;
	;	DPC	20160815
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_Struct
	s_ptr = PTR_Struct.PTR_summary
	w_ptr = PTR_Struct.PTR_wid
	;
	win_UL = (*w_ptr).Plot_Window[0]	; window plot numbers
	win_UR = (*w_ptr).Plot_Window[1]
	win_LL = (*w_ptr).Plot_Window[2]
	win_LR = (*w_ptr).Plot_Window[3]
	win_BT = (*w_ptr).Plot_Window[4]
	win_BB = (*w_ptr).Plot_Window[5]
	win_Main = (*w_ptr).Plot_Window[6]
	;
	;	key constants
	;
	sPA_min = (*w_ptr).Term_textbox_value[0]	; degrees - term1
	pa_start = (*w_ptr).Term_textbox_value[1]	; bins - term2
	pa_end = (*w_ptr).Term_textbox_value[2]		; term3
	dpa_step = (*w_ptr).Term_textbox_value[3]	; term4
	;
	px_per_p = (*w_ptr).Term_textbox_value[4]	; pixels to plot per percentage polarization
	;
;	rad_inner = 250.0	; inside is 'inner' outside is 'outer' radii
	rad_inner = (*w_ptr).Term_textbox_value[5]
	;
;	mag_max = 13.0		; maximum H-band magnitude permitted
	mag_max = (*w_ptr).Term_textbox_value[6]
	;
	npa = FLOOR((pa_end - pa_start)/dpa_step)+1.0
	bin_xpa = (findgen(npa)+0.5)*dpa_step + pa_start	; bin center
	bin_ypa = intarr(npa)
	;
	;	files read in yet?
	;
	if((*s_ptr).npaths eq 0) then begin
		print_text, Event, 'ERROR - no POLCATS selected'
		print_text, Event, 'Use File Chooser to Select POLCATS'
		goto, quick_end
	endif
	;
	nfiles = (*s_ptr).npaths
	files = (*s_ptr).paths
	;
	seeing = fltarr(nfiles)
	date_im0 = strarr(nfiles)
	;
	;	scoring collection
	;
	metric_value = fltarr(8,nfiles)		; values evaluated to create score
	metric_score = intarr(8,nfiles)		; +1, 0, -1 digital scores for each metric
	;
	for ifile = 0, nfiles-1 do begin
		;
		device, decomposed =0
		loadct, 13, /SILENT
		tvlct, [0,255,255,0,0,148,235,225,100], [0,255,0,0,128,0,185,20,100], [0,255,0,255,0,211,15,147,100], 0
		black = 0 & white = 1 & red = 2 & blue = 3 & green = 4 & violet = 5 & yellow = 6 & pink = 7 & gray = 8
		pthick = 2
		cthick = 2
		chsz = 1.00
		;
		infile = files[ifile]
		field_name = FILE_BASENAME(infile,'_POLCAT.dat')
		;
		;	read the file
		;
		data = read_polcat(infile)
		;
		;	save date and seeing - if meta-group, form average
		;
		this_seeing = data.pol_head.fwhm_cor
		if(N_ELEMENTS(this_seeing) gt 1) then begin
			zz = median_filtered_mean(this_seeing)
			this_seeing = zz[0]
		endif
		seeing[ifile] = this_seeing
		this_date = data.pol_head.image_0
		;
		;	if more than one date, though, just give first
		;
		if(N_ELEMENTS(this_date) gt 1) then begin
			this_date = REFORM(this_date[0])
		endif
		;
		nd = STRLEN(this_date)
		this_date = STRMID(this_date,0,nd-10)
		date_im0[ifile] = this_date
		;
		;	for every entry, compute the field-centered position angle to the star
		;	assuming the center is at 50% of the image size in both directions
		;
		xcen = 511.5
		ycen = 512.5
		;
		nstars = N_ELEMENTS(data.s.num)
		;
		dx = data.s[*].x_det - xcen
		dy = data.s[*].y_det - ycen
		;
		field_pa = (720.0 -90.0 + 57.295 * atan(dy,dx)) mod 360.0 ; to go from xy -> PA
		field_rad = sqrt(dx*dx + dy*dy)
		;
		field_mag = data.s[*].H_mag
		;
		ind = where((data.s[*].sPA le sPA_min) and (field_mag le mag_max),ngood)
		;
		if(ngood le 5) then begin
			print_text,Event,'Too few stars (ngood=)'+STRING(ngood,format='(i)')+') - reset parameters and retest'
			goto, quick_end
		endif
		;
		;
		print_text, Event, STRING(field_name,ngood,nstars,$
			format='(a," Ngood = ",I4," of ",I5," total stars ")')
		print_text, Event, '  Date.IM0, Seeing, mag_max = '+STRING(this_date,this_seeing,mag_max,$
			format='(a13,3x,f5.3,2x,f4.1)')
		;
		;	select polarization percentages, also
		;
		field_rad = field_rad[ind]
		field_pol = data.s[ind].P
		field_sPol = data.s[ind].sP
		field_gpa = data.s[ind].gpa_deg
		field_epa = data.s[ind].PA_deg
		field_pa = field_pa[ind]
		field_spa = data.s[ind].sPA
		;
		dx = dx[ind]
		dy = dy[ind]
		;
		;	Main plot of polarization P, PA vs location
		;
		WSET, win_Main
		erase
		;
		xmar = [7,1.5]
		xmar0 = [9,3]
		ymar = [4,1]
		;
		plot, [-550,550], [-550,550],xr=[-550,550],xs=1,yr=[-550,550],ys=1,/nodata,$
			xtitle='X pixel offset',ytitle='Y pixel offset',$
			thick=pthick,color=white,charsize=chsz,xtickinterval=100,ytickinterval=100,$
			xmar=xmar0,ymar=ymar,xminor=4,yminor=4
		;
		;	vector half-length offsets from center positions
		;
		yoff = px_per_p * cos(field_epa / 57.296) * field_pol
		xoff = px_per_p * sin(field_epa / 57.296) * field_pol
		;
		;	plot vectors
		;
		for js = 0, ngood-1 do begin
			ys0 = dy[js] - yoff[js]
			ys1 = dy[js] + yoff[js]
			xs0 = dx[js] + xoff[js]
			xs1 = dx[js] - xoff[js]
			;
			if(field_spa[js] le 0.5 * sPA_min) then clr = yellow else clr = green
			oplot, [xs0,xs1], [ys0,ys1],psym=-3,symsize=0.002,color=clr,thick=1
			;
		endfor
		;
		;	UL plot of PA vs PA
		;
		WSET, win_UL
		erase
		;
		plot, [0, 360], [0, 360],xr=[0,360],xs=1,yr=[0,360],ys=1,/nodata,$
			xtitle='Field PA [deg]',ytitle='Polarization PA [deg]',$
			thick=pthick,color=white,charsize=chsz,xtickinterval=45,ytickinterval=45,$
			xmar=xmar,ymar=ymar,xminor=3,yminor=3
		;
		pclr = intarr(ngood)
		indc = WHERE(field_rad le rad_inner,ninner,COMPLEMENT=indc_c,NCOMPLEMENT=nindc_c)
		if(ninner gt 0) then begin
			pclr[indc] = gray
		endif
		if(nindc_c gt 0) then begin
			pclr[indc_c] = blue
		endif
		for jc = 0, ngood-1 do begin
			plots, field_pa[jc],field_epa[jc], psym=4,color=pclr[jc],thick=pthick,symsize=0.25
		endfor
		if(nindc_c gt 0) then begin
			pclr[indc_c] = green
		endif
		for jc = 0, ngood-1 do begin
			plots, field_pa[jc],180.0+field_epa[jc], psym=4,color=pclr[jc],thick=pthick,symsize=0.25
		endfor
		;
		xyouts, 45, 330, field_name, charsize=chsz*1.5, charthick=cthick, color=red
		;
		;	add galactic plane dashed lines
		;
		gpa90 = (720.0 + (data.s[0].pa_deg +90.0 - data.s[0].gpa_deg)) MOD 180
		;
		oplot, [0.,360.],gpa90*[1.,1.],psym=-3, $
				symsize=0.002,thick=pthick,color=pink,linestyle=1
		xyouts, 180.0, gpa90+20.,'Galactic Plane',charsize=chsz*1.5,color=pink,charthick=cthick
		;
		oplot, [0.,360.],(gpa90+180.0)*[1.,1.],psym=-3, $
				symsize=0.002,thick=pthick,color=pink,linestyle=1
		;
		;  plot histogram of stars in diagonal bins
		;
		WSET, win_UR
		erase
		;
		;	bin by diagonal zone
		;
		bin_ypa[*] = 0
		;
		ibin = floor((field_pa - field_epa - (dpa_step / 2.0) - pa_start) / dpa_step)
		ibin >= 0
		ibin <= (npa-1)
		;
		for ib = 0, npa-1 do begin
			indb = where(ibin eq ib,nb)
			bin_ypa[ib] = nb
		endfor
		;
		ymax = max(bin_ypa) * 1.05
		;
		;average = moment(bin_ypa)
		;peak_to_average = max(bin_ypa) / (average[0])
		;print_text, Event, 'Peak to Average ratio = '+STRING(peak_to_average,format='(F6.3)')
		;
		xmar2 = [6,1.75]
		plot, bin_xpa, bin_ypa, xr=[pa_start,pa_end],xs=1,yr = [0.,ymax],ys=1,$
			xtitle='Bin center offset [deg]',ytitle='Binned star counts',$
			xmar=xmar2,ymar=ymar,$
			thick=pthick,color=white,charsize=chsz,xtickinterval=45,ytickinterval=10,$
			xminor=3,yminor=4,/nodata
		;
		;	E, B zones shown on plot as hashed lines
		;
		e0 = -180.0
		e1 = e0 + 22.5
		this = 'e'
		b0 = 0.0
		b1 = 0.0
		;
		WHILE (e0 lt 360.0 and b0 lt 360.0) do begin
			case this of
				'e':	begin
							xp = [e0, e1, e1, e0, e0]
							yp = [0, 0, ymax, ymax, 0]
							polyfill, xp, yp, color=blue, /line_fill, spacing=0.5, orientation=45, thick=2
							;
							this = 'b'
							b0 = e1
							b1 = (b0 + 45.0) < 360.0
						end
				'b':	begin
							xp = [b0, b1, b1, b0, b0]
							polyfill, xp, yp, color=violet, /line_fill, spacing=0.5, orientation=-45, thick=2
							;
							this = 'e'
							e0 = b1
							e1 = (e0 + 45) < 360.0
						end
			endcase
		ENDWHILE
		;
		plot, bin_xpa, bin_ypa, xr=[pa_start,pa_end],xs=1,yr = [0.,ymax],ys=1,/noerase,$
			xtitle='Bin center offset [deg]',ytitle='Binned star counts',$
			xmar=xmar2,ymar=ymar,$
			thick=pthick,color=white,charsize=chsz,xtickinterval=45,ytickinterval=10,$
			xminor=3,yminor=4,/nodata
		;
		;	do a n*90 deg fold
		;
		nfold = 2
		;
		fxbin = (720.0 + bin_xpa) mod (nfold*90)
		nnewbins = ROUND(nfold*90.0 / dpa_step)
		newxbins = dpa_step * (findgen(nnewbins)+0.5)
		;
		newy = fltarr(nnewbins)
		for k = 0, nnewbins-1 do begin
			indn = WHERE(fxbin eq newxbins[k], nk)
			if(nk gt 0) then begin
				newy[k] = total(bin_ypa[indn])
			endif else begin
				newy[k] = 0.0
			endelse
		endfor
		;
		ind_sort = SORT(newy)
		;
		low = newy[ind_sort[0:2]]
		high = newy[ind_sort[nnewbins-3:nnewbins-1]]
		;
		zz_low = median_filtered_mean(low)
		zz_high = median_filtered_mean(high)
		;
		pk = zz_high[0]
		tr = zz_low[0]
		;
		;**
		zz_all = median_filtered_mean(newy)
		tr = zz_all[0]
		;
		pt_ratio = float(pk - tr) / float(pk + tr)
		;
		; evaluate relative power in four angle zones (20-65, 65-110, 110 - 155, 155-180+0-20 deg)
		;
		ind1 = where((newxbins ge 0.0 and newxbins lt 20.0) or (newxbins ge 155.0 and newxbins le 180.0),n1)
		ind2 = where(newxbins ge 20.0 and newxbins lt 65.0,n2)
		ind3 = where(newxbins ge 65.0 and newxbins lt 110.0,n3)
		ind4 = where(newxbins ge 110.0 and newxbins lt 155.0,n4)
		;
		;	counts in each?
		;
		if(n1 gt 0) then nt1 = TOTAL(newy[ind1]) else nt1 = 0
		if(n2 gt 0) then nt2 = TOTAL(newy[ind2]) else nt2 = 0
		if(n3 gt 0) then nt3 = TOTAL(newy[ind3]) else nt3 = 0
		if(n4 gt 0) then nt4 = TOTAL(newy[ind4]) else nt4 = 0
		;
		nt = [nt1, nt2, nt3, nt4]
		snt = sqrt(float(nt))
		ind_snt = WHERE(snt eq 0.0,nind_snt)
		if(nind_snt gt 0) then begin
			snt[ind_snt] = 200.0			; set uncertainty very high
		endif
		;
		nt_max = max(nt,idt)
		;
		;	get mean, uncert
		;
		istart = 1
		for jj = 0, 3 do begin
			if(idt ne jj) then begin
				if(istart eq 1) then begin
					nt_trim = [nt[jj]]
					snt_trim = [snt[jj]]
					istart++
				endif else begin
					nt_trim = [nt_trim,nt[jj]]
					snt_trim = [snt_trim,snt[jj]]
				endelse
			endif
		endfor
		;
		;	average of other quads
		;
		qave = weighted_mean(nt_trim,snt_trim)
		;
		;	difference of highest, in sigmas
		;
		nt_excess = nt_max - qave[0]
		snt_excess = sqrt(snt[idt]^2 + qave[1]^2)
		;
		signif = nt_excess / snt_excess
		;
		case idt of
			0: begin
				q0 = 155
				q1 = 20
			   end
			1: begin
				q0 = 20
				q1 = 65
			   end
			2: begin
				q0 = 65
				q1 = 110
			   end
			3: begin
			  	q0 = 110
			  	q1 = 155
			   end
		endcase
		;
		;	if the strongest quarter is number 3 (tangent), score  = +1
		;	if strongest is number 1 (radial), score = 0
		;	others are -1
		;
		metric_value[0,ifile] = nt_max + signif/100.0
		;
		case idt of
			0: begin
				if(signif ge 3.0) then ms = +1
				if(signif lt 3.0) then ms = 0
				if(signif lt 1.5) then ms = -1
			   end
			1: begin
				if(signif ge 5.0) then ms = +1
				if(signif ge 2.5) then ms = 0
				if(signif lt 2.5) then ms = -1
			   end
			2: begin
				if(signif ge 3.0) then ms = +1
				if(signif lt 3.0) then ms = 0
				if(signif lt 1.5) then ms = -1
			   end
			3: begin
				if(signif ge 5.0) then ms = +1
				if(signif ge 2.5) then ms = 0
				if(signif le 2.5) then ms = -1
			   end
		endcase
		;
		metric_score[0,ifile] = ms
		;
		case ms of
			-1: begin
					clr0 = 'green'
					clr0p = green
				end
			 0: begin
			 		clr0 = 'yellow'
			 		clr0p = yellow
			 	end
			+1: begin
					clr0 = 'red'
					clr0p = red
				end
		endcase
		;
		oplot, bin_xpa, bin_ypa, psym=-4, thick=cthick*1.5, symsize=chsz*1.5, color=clr0p
		;
		print_text,Event,'Test 1: ['+STRING(ms,format='(I2)')+'] Dominant Folded Quartile = '+STRING(q0,q1,format='(I3," to ",I3)')+' deg'
		if(idt eq 2) then print_text, Event,'   This is the TANGENT quartile'
		if(idt eq 0) then print_text, Event,'   This is the RADIAL quartile'
		;
		;	plot folded counts vs offset angle
		;
		WSET, win_LL
		erase
		;
		; eval P/T ratio, based on peak phase
		;
		metric_value[1,ifile] = pt_ratio
		;
		if(pt_ratio lt 0.35) then begin
			ms = -2
			clr1 = 'green'
			clr1p = green
		endif
		if(pt_ratio gt 0.35) then begin
			ms = 0
			clr1 = 'yellow'
			clr1p = yellow
		endif
		if(pt_ratio gt 0.45) then begin
			ms = +2
			clr1 = 'red'
			clr1p = red
		endif
		;
		metric_score[1,ifile] = ms
		;
		print_text, Event, 'Test 2: ['+STRING(ms,format='(I2)')+'] PA vs PA P-to-RMS ratio = '+STRING(pt_ratio,format='(F6.4)')
		;
		ymin = min(newy)
		ymax = max(newy)
		dy = ymax - ymin
		ymin -= 0.07*dy
		ymax += 0.05*dy
		;
		xmar3 = [7,1.5]
		;
		plot, newxbins, newy, xr=[0.,nfold*90.],xs=1,yr = [ymin,ymax],ys=1,$
			xtitle='Folded Bin center offset [deg]',ytitle='Folded Bin counts',$
			xmar=xmar3,ymar=ymar,$
			thick=pthick,color=white,charsize=chsz,xtickinterval=20,ytickinterval=15,$
			xminor=2,yminor=3,/nodata
		;
		oplot, newxbins, newy, psym=-4, thick=cthick, symsize=chsz*1.5, color=clr1p
		;
		;   draw them
		;
		oplot,[min(newxbins[ind_sort[0:2]]),max(newxbins[ind_sort[0:2]])],zz_low[0]*[1.,1.],$
			psym=-3,symsize=0.002,thick=2.0*pthick,color=white
		;
		oplot,[min(newxbins[ind_sort[nnewbins-3:nnewbins-1]]),max(newxbins[ind_sort[nnewbins-3:nnewbins-1]])],zz_high[0]*[1.,1.],$
			psym=-3,symsize=0.002,thick=2.0*pthick,color=white
		;
		;	4th plot - P vs rad
		;
		WSET, win_LR
		erase
		;
		xmar4 = [6,1.5]
		plot, field_rad, field_pol, xr=[0.,720.],xs=1,yr = [0.,8.],ys=1,$
			xtitle='Center radial offset [pix]',ytitle='P Percentage',$
			xmar=xmar4,ymar=ymar,$
			thick=pthick,color=white,charsize=chsz,xtickinterval=100,xminor=2,$
			ytickinterval=1.0,yminor=4,/nodata
		;
		a = poly_fit(0.01*field_rad, field_pol,1, sigma=sigma_a,measure_errors=field_sPol)
		;
		xyouts, 50, 6.8, string(a[0],sigma_a[0],$
			format='("P=",f7.3," (",f6.3,") + ")'),$
			charsize=chsz,color=white,charthick=pthick
		xyouts, 120, 5.8, string(a[1],sigma_a[1],$
			format='(f7.4," (",f6.4,") * Rad [100pix]")'),$
			charsize=chsz,color=white,charthick=pthick
		;
		; slope and SNR(slope)
		;
		;		metric value is +SNR if slope positive, -SNR if slope negative
		;
		SNR = abs(a[1])/sigma_a[1]
		;
		if((a[1]+1.5*sigma_a[1]) gt 0.0) then begin
			metric_value[2,ifile] = SNR
			if(SNR le 3.0) then begin
				ms = -1
				clr2 = 'green'
				clr2p = green
			endif
			if(SNR gt 3.0) then begin
				ms = 0
				clr2 = 'yellow'
				clr2p = yellow
			endif
			if(SNR gt 12.0) then begin
				ms = +1
				clr2 = 'red'
				clr2p = red
			endif
			if(SNR gt 20.0) then begin
				ms = +2
				clr2 = 'red'
				clr2p = red
			endif
		endif else begin
			metric_value[2,ifile] = -SNR
			ms = -2
			clr2 = 'green'
			clr2p = green
		endelse
		;
		oplot, field_rad, field_pol, psym=4, thick=cthick*1.5, symsize=0.25, color=gray
		oplot, [0.,750.], a[0]+a[1]*[0.,7.500],psym=-3, thick=1.5*cthick, color=clr2p,linestyle=1
		;
		;
		;** override metric to be slope
		;
		metric_value[2,ifile] = a[1]
		;
		metric_score[2,ifile] = ms
		print_text, Event, 'Test 3: ['+STRING(ms,format='(I2)')+'] P vs offset: slope = '+STRING(metric_value[2,ifile],format='(f7.3)')
		;
		;	bin into 100 bin wide zones, average within each
		;
		nrbins = 7
		xbin0 = findgen(nrbins)*100.0
		xbin1 = xbin0+100.0
		;
		pbins = fltarr(nrbins,2000)
		pbins_mean = fltarr(nrbins)
		spbins = fltarr(nrbins,2000)
		pbins_rms = fltarr(nrbins)
		npbins = intarr(nrbins)
		;
		for k = 0, N_ELEMENTS(field_rad)-1 do begin
			this_bin = field_rad[k] - xbin0[0]
			this_bin /= (xbin1[0] - xbin0[0])
			this_bin = FLOOR(this_bin)
			;
			if(this_bin ge 0 and this_bin le (nrbins-1)) then begin
				pbins[this_bin,npbins[this_bin]] = field_pol[k]
				spbins[this_bin,npbins[this_bin]] = field_sPol[k]
				npbins[this_bin]++
			endif
		endfor
		;
		for j = 0, nrbins-1 do begin
			if(npbins[j] gt 0) then begin
				if(npbins[j] gt 1) then begin
					;
					;	trap PA uncertainties at no lower than 0.2 %
					;
					spbins[j,0:(npbins[j]-1)] >= 0.2
					wt = REFORM((1./spbins[j,0:(npbins[j]-1)])^2)
					;
					wt_pbins = wt * REFORM(pbins[j,0:(npbins[j]-1)])
					;
					pbins_mean[j] = TOTAL(wt_pbins) / TOTAL(wt)
					pbins_rms[j] = 1.0 / TOTAL(wt)
				endif else begin
					pbins_rms[j] = pbins[j,0]
					pbins_mean[j] = pbins[j,0]
				endelse
			endif
		endfor
		;
		ybin0 = pbins_mean
		ybin0_rms = pbins_rms
		znd = WHERE(ybin0_rms le 0.0,nz)
		if(nz gt 0) then begin
			;
			;	uncertainty for zero counts set to 1%
			;
			ybin0_rms[znd] = 1.0
		endif
		;
		;		average of inner three versus average of outer three
		;
		inner = weighted_mean(ybin0[0:2],ybin0_rms[0:2])	; TOTAL(ybin0[0:2])/3.0
		outer = weighted_mean(ybin0[4:6],ybin0_rms[4:6])	; TOTAL(ybin0[4:6])/3.0
		;
		p_ratio = outer[0] / inner[0]
		;
		sp_ratio = p_ratio * sqrt( (inner[1]/inner[0])^2 + (outer[1]/outer[0])^2)
		;
		SNR_P_ratio = abs(p_ratio) / sp_ratio
		;
		metric_value[3,ifile] = float((round(10.0*p_ratio))/10)+SNR_P_ratio / 100.0
		;
		if(p_ratio+sp_ratio lt 1.5) then begin
			ms = -1
			clr3 = 'green'
			clr3p = green
		endif
		if(p_ratio+sp_ratio gt 1.5) then begin
			ms = 0
			clr3 = 'yellow'
			clr3p = yellow
		endif
		if(p_ratio-2.5*sp_ratio gt 2.0) then begin
			ms = +1
			clr3 = 'red'
			clr3p = red
		endif
		;
		for j = 0, nrbins-1 do begin
			oplot, [xbin0[j],xbin1[j]],ybin0[j]*[1.,1.],thick=cthick*1.5,color=clr3p,psym=-3,symsize=0.001
			oplot, 0.5*(xbin0[j]+xbin1[j])*[1.,1.],ybin0[j]+ybin0_rms[j]*[-1.,1.],thick=cthick*1.5,color=clr3p,psym=-3,symsize=0.001
		endfor
		metric_score[3,ifile] = ms
		;
		print_text, Event, 'Test 4: ['+STRING(ms,format='(I2)')+'] P_Outer / P_Inner ratio = '+STRING(p_ratio,format='(F6.3)')
		;
		;	BT plot - binning of counts versus GPA
		;
		WSET, win_BT
		erase
		;
		ngpa_bins = CEIL(180.0 / dPA_step)
		;
		gpa_histo = HISTOGRAM(field_gpa,nbins=ngpa_bins,min=0.,max=180.,locations=gpa_x)
		;
		plot, gpa_x,gpa_histo, psym=10,xr=[0.,180.],xs=1,yr = [0.,1.05*max(gpa_histo)],ys=1,$
			xtitle='Galactic Position Angle [deg]',ytitle='Number of Stars',$
			xmar=xmar,ymar=ymar,$
			thick=pthick,color=white,charsize=chsz,xtickinterval=30,xminor=3,$
			ytickinterval=20,yminor=4,/nodata
		;
		oplot, gpa_x, gpa_histo, psym=10, thick=cthick*1.5, symsize=0.25, color=gray
		;
		;	find peak to trough ratio, using average of highest three for each
		;
		;	9/5/16 - replace trough with rms of all
		;
		zz_all = median_filtered_mean(gpa_histo)
		;
		ind_sort = sort(gpa_histo)
		low = gpa_histo[ind_sort[0:2]]
		high = gpa_histo[ind_sort[ngpa_bins-3:ngpa_bins-1]]
		zz_low = median_filtered_mean(low)
		zz_high = median_filtered_mean(high)
		;
		;	correct to unc of mean
		;
		zz_low[1] /= 1.414
		zz_high[1] /= 1.414
		;
		;**
		zz_low[0] = zz_all[0]
		;
		pk_tr_ratio = (zz_high[0] - zz_low[0]) / (zz_high[0] + zz_low[0])
		;
		;	eval P/T first
		;
		metric_value[4,ifile] = pk_tr_ratio
		;
		if(pk_tr_ratio gt 0.3) then begin	; SNR=2.5
			ms = 0
			clr4 = 'yellow'
			clr4p = yellow
		endif
		if(pk_tr_ratio le 0.3) then begin
			ms = +1
			clr4 = 'red'
			clr4p = red
		endif
		if(pk_tr_ratio gt 0.6) then begin	; SNR=4
			ms = -1
			clr4 = 'green'
			clr4p = green
		endif
		;
		;   draw them
		;
		oplot,[min(gpa_x[ind_sort[0:2]]),max(gpa_x[ind_sort[0:2]])],zz_low[0]*[1.,1.],$
			psym=-3,symsize=0.002,thick=pthick,color=clr4p
		;
		oplot,[min(gpa_x[ind_sort[ngpa_bins-3:ngpa_bins-1]]),max(gpa_x[ind_sort[ngpa_bins-3:ngpa_bins-1]])],zz_high[0]*[1.,1.],$
			psym=-3,symsize=0.002,thick=pthick,color=clr4p
		;
		metric_score[4,ifile] = ms
		;
		print_text, Event, 'Test 5: ['+STRING(ms,format='(I2)')+'] GPA Pk to RMS ratio = '+STRING(pk_tr_ratio,$
				format='(f6.3)')
		;
		;	and examine fraction of counts in top two bins.
		;
		frac_in_top2 = (gpa_histo[ind_sort[ngpa_bins-1]] + gpa_histo[ind_sort[ngpa_bins-2]]) / TOTAL(gpa_histo)
		;
		metric_value[5,ifile] = frac_in_top2
		;
		if(frac_in_top2 le 0.25) then begin
			ms = +1
			clr5 = 'red'
			clr5p = red
		endif
		if(frac_in_top2 gt 0.25) then begin
			ms = 0
			clr5 = 'yellow'
			clr5p = yellow
		endif
		if(frac_in_top2 ge 0.30) then begin
			ms = -1
			clr5 = 'green'
			clr5p = green
		endif
		;
;		dx = gpa_x[1]-gpa_x[0]
;		dx /= 2.
		oplot, (gpa_x[ind_sort[ngpa_bins-1]])*[1.,1.],gpa_histo[ind_sort[ngpa_bins-1]]*0.9*[0.,1.],psym=-3,$
			symsize=0.002,thick=cthick*1.5,color=clr5p
		;
		oplot, (gpa_x[ind_sort[ngpa_bins-2]])*[1.,1.],gpa_histo[ind_sort[ngpa_bins-2]]*0.9*[0.,1.],psym=-3,$
			symsize=0.002,thick=cthick*1.5,color=clr5p
		;
		metric_score[5,ifile] = ms
		;
		print_text, Event, 'Test 6: ['+STRING(ms,format='(I2)')+'] Frac in top2 GPA histo bins = '+STRING(frac_in_top2,format='(f6.3)')
		;
		;	NESW zone modulation test
		;
		buffer = 10.0
		zind1 = WHERE((field_rad gt rad_inner) and ( (field_pa ge 0.0 and field_pa lt (45.0-buffer)) $
								or (field_pa ge (315.+buffer) and field_pa lt 360.0)),nz1)
		zind2 = WHERE((field_rad gt rad_inner) and (field_pa ge (45.0+buffer) and field_pa lt (135.0-buffer)),nz2)
		zind3 = WHERE((field_rad gt rad_inner) and (field_pa ge (135.0+buffer) and field_pa lt (225.0-buffer)),nz3)
		zind4 = WHERE((field_rad gt rad_inner) and (field_pa ge (225.0+buffer) and field_pa lt (315.0-buffer)),nz4)
		;
		;	check that all zones have counts, if not, skip this test
		;
		if(min([nz1,nz2,nz3,nz4]) gt 0) then begin
			;
			;	trap pa uncertainties at no lower than 2 deg
			;
			spa_trap = field_spa > 2.0
			;
			;	compute mean PA and uncert for each of these zones
			;
	;		z1 = weighted_mean(field_epa[zind1],spa_trap[zind1])
	;		z2 = weighted_mean(field_epa[zind2],spa_trap[zind2])
	;		z3 = weighted_mean(field_epa[zind3],spa_trap[zind3])
	;		z4 = weighted_mean(field_epa[zind4],spa_trap[zind4])
			;
			;	compute histograms of position angles in each zone
			;
			z1_histo = histogram(field_epa[zind1],min=0.,max=180.,binsize=dPA_step,LOCATIONS=xz_histo)
			z2_histo = histogram(field_epa[zind2],min=0.,max=180.,binsize=dPA_step)
			z3_histo = histogram(field_epa[zind3],min=0.,max=180.,binsize=dPA_step)
			z4_histo = histogram(field_epa[zind4],min=0.,max=180.,binsize=dPA_step)
			;
			;	find peak, gaussian fit it
			;
			z1_pk = max(z1_histo,z1ind)
			nterms = 4
			z1_est = [z1_pk,xz_histo[z1ind]+0.5*dPA_step,7.0,3.0]
			z1_fit = GAUSSFIT(xz_histo+0.5*dPA_step, z1_histo , A1, CHISQ=chi1, $
					ESTIMATES=z1_est, NTERMS=nterms, SIGMA=sA1)
			;
			z2_pk = max(z2_histo,z2ind)
			nterms = 4
			z2_est = [z2_pk,xz_histo[z2ind]+0.5*dPA_step,7.0,3.0]
			z2_fit = GAUSSFIT(xz_histo+0.5*dPA_step, z2_histo , A2, CHISQ=chi2, $
					ESTIMATES=z2_est, NTERMS=nterms, SIGMA=sA2)
			;
			z3_pk = max(z3_histo,z3ind)
			nterms = 4
			z3_est = [z3_pk,xz_histo[z3ind]+0.5*dPA_step,7.0,3.0]
			z3_fit = GAUSSFIT(xz_histo+0.5*dPA_step, z3_histo , A3, CHISQ=chi3, $
					ESTIMATES=z3_est, NTERMS=nterms, SIGMA=sA3)
			;
			z4_pk = max(z4_histo,z4ind)
			nterms = 4
			z4_est = [z4_pk,xz_histo[z4ind]+0.5*dPA_step,7.0,3.0]
			z4_fit = GAUSSFIT(xz_histo+0.5*dPA_step, z4_histo , A4, CHISQ=chi4, $
					ESTIMATES=z4_est, NTERMS=nterms, SIGMA=sA4)
			;
			z1 = [((720.0 + A1[1]) mod 180.0),sA1[1]]
			z2 = [((720.0 + A2[1]) mod 180.0),sA2[1]]
			z3 = [((720.0 + A3[1]) mod 180.0),sA3[1]]
			z4 = [((720.0 + A4[1]) mod 180.0),sA4[1]]
			;
	;		print, 'Z1,2,3,4 = ',z1,z2,z3,z4
			;
			;	if desired, plot
			;
			extra_plot = 0
			;
			if(extra_plot eq 1) then begin
				WSET,win_main
				erase
				yr = [0.,max([z1_histo,z2_histo,z3_histo,z4_histo])]
				plot, [0.,180.],yr,xs=1,yr=[yr[0],1.05*yr[1]],ys=1,/nodata,$
					xtitle='EPA [deg]',ytitle='N stars',$
					thick=pthick,color=white,charsize=chsz,xtickinterval=30,ytickinterval=10,$
					xmar=xmar,ymar=ymar,xminor=3,yminor=5,/noerase
				oplot, xz_histo+0.5, z1_histo, psym=-3,thick=pthick,color=red
				oplot, xz_histo+0.5,z1_fit,psym=4,thick=2.0*pthick,color=red

				oplot, xz_histo+0.5, z2_histo, psym=-3,thick=pthick,color=green
				oplot, xz_histo+0.5,z2_fit,psym=4,thick=2.0*pthick,color=green

				oplot, xz_histo+0.5, z3_histo, psym=-3,thick=pthick,color=violet
				oplot, xz_histo+0.5,z3_fit,psym=4,thick=2.0*pthick,color=violet

				oplot, xz_histo+0.5, z4_histo, psym=-3,thick=pthick,color=blue
				oplot, xz_histo+0.5,z4_fit,psym=4,thick=2.0*pthick,color=blue
			endif
			;
			;	test 1, are Z1 and Z3 within dz deg and the same for Z2 and Z4?
			;
			dz = 20.0
			ztest1a = ((720.0 + abs(z1[0] - z3[0])) mod 180.0) lt dz
			ztest1b = ((720.0 + abs(z2[0] - z4[0])) mod 180.0) lt dz
			ztest1c = ((720.0 + abs(z3[0] - z1[0])) mod 180.0) lt dz
			ztest1d = ((720.0 + abs(z4[0] - z2[0])) mod 180.0) lt dz
			;
			ztest1 = (ztest1a and ztest1b) or (ztest1c and ztest1d) or (ztest1a and ztest1d) or (ztest1b and ztest1c)
			;
			;	test 2, are the odd-even differences near 90 deg?
			;
			diff_ang = (720.0 + ((z1[0]+z3[0])/2. - (z2[0]+z4[0])/2.)) mod 180.0
			diff_ang2 = (720.0 + ((z2[0]+z4[0])/2. - (z1[0]+z3[0])/2.)) mod 180.0
			;
			ztest2 = (abs(diff_ang - 90.0) le 15.0) or (abs(diff_ang2 - 90.0) le 15.0)
			;
			;	if both are true, then go back to the PA vs PA plot and add colored lines
			;
			WSET, win_UL
			plot, [0, 360], [0, 360],xr=[0,360],xs=1,yr=[0,360],ys=1,/nodata,$
				xtitle='Field PA [deg]',ytitle='Polarization PA [deg]',$
				thick=pthick,color=white,charsize=chsz,xtickinterval=45,ytickinterval=45,$
				xmar=xmar,ymar=ymar,xminor=3,yminor=3,/noerase
			;
			if(ztest1 and ztest2) then begin
				;
				this_clr = red
				;
				metric_value[6,ifile] = diff_ang < diff_ang2
				metric_score[6,ifile] = +5
				clr6 = 'red'
			endif else begin
				;
				; redo ztest1 with 15 deg, if passes and ztest2 still true = yellow, else green
				;
				;ztest3 = (abs(z1[0] - z3[0]) lt 10.0) and (abs(z2[0] - z4[0]) lt 10.0)
				dz = 20.0
				ztest3a = ((720.0 + abs(z1[0] - z3[0])) mod 180.0) lt dz
				ztest3b = ((720.0 + abs(z2[0] - z4[0])) mod 180.0) lt dz
				ztest3c = ((720.0 + abs(z3[0] - z1[0])) mod 180.0) lt dz
				ztest3d = ((720.0 + abs(z4[0] - z2[0])) mod 180.0) lt dz
				;
				ztest3 = (ztest3a and ztest3b) or (ztest3c and ztest3d) or (ztest3a and ztest3d) or (ztest3b and ztest3c)
				;
				ztest4 = (abs(diff_ang - 90.0) le 2*15.0) or (abs(diff_ang2 - 90.0) le 2*15.0)
				;
				;
				if(ztest3 and ztest4) then begin
					;
					this_clr = yellow
					;
					metric_value[6,ifile] = diff_ang < diff_ang2
					metric_score[6,ifile] = +1
					clr6 = 'yellow'
				endif else begin
					;
					this_clr = green
					;
					metric_value[6,ifile] = diff_ang < diff_ang2
					metric_score[6,ifile] = -1
					clr6 = 'green'
				endelse
			endelse
			;
			oplot, [0.,(45.-buffer)],z1[0]*[1.,1.],psym=-3,symsize=0.002,thick=pthick,color=this_clr
			oplot, [(315.+buffer),360.],z1[0]*[1.,1.],psym=-3,symsize=0.002,thick=pthick,color=this_clr
			oplot, [0.,(45.-buffer)],(z1[0]+180.0)*[1.,1.],psym=-3,symsize=0.002,thick=pthick,color=this_clr
			oplot, [(315.+buffer),360.],(z1[0]+180.0)*[1.,1.],psym=-3,symsize=0.002,thick=pthick,color=this_clr
			;
			oplot, [(45.+buffer),(135.-buffer)],z2[0]*[1.,1.],psym=-3,symsize=0.002,thick=pthick,color=this_clr
			oplot, [(45.+buffer),(135.-buffer)],(z2[0]+180.0)*[1.,1.],psym=-3,symsize=0.002,thick=pthick,color=this_clr
			;
			oplot, [(135.+buffer),(225.-buffer)],z3[0]*[1.,1.],psym=-3,symsize=0.002,thick=pthick,color=this_clr
			oplot, [(135.+buffer),(225.-buffer)],(z3[0]+180.0)*[1.,1.],psym=-3,symsize=0.002,thick=pthick,color=this_clr
			;
			oplot, [(225.+buffer),(315.-buffer)],z4[0]*[1.,1.],psym=-3,symsize=0.002,thick=pthick,color=this_clr
			oplot, [(225.+buffer),(315.-buffer)],(z4[0]+180.0)*[1.,1.],psym=-3,symsize=0.002,thick=pthick,color=this_clr
			;
		endif else begin
			metric_value[6,ifile] = -9.999
			metric_score[6,ifile] = 0
			clr6 = 'pink'
		endelse
		;
		print_text, Event, 'Test 7: ['+STRING(metric_score[6,ifile],format='(I2)')+$
					'] NESW PA Offset = '+STRING(metric_value[6,ifile],format='(f6.2)')
		;
		;
		;	show classification as a color bar - one test per zone
		;
		color = strarr(7)
		color = [clr0,clr1,clr2,clr3,clr4,clr5,clr6]
		;
		WIDGET_CONTROL, (*w_ptr).Classification_label_wid, SET_VALUE='Test Results'
		;
		EB_led_stack, (*w_ptr).Classification_draw_window_wid, color
		;
		total_metric_score = TOTAL(REFORM(metric_score[0:6,ifile]))
		;
		metric_value[7,ifile] = total_metric_score
		;
		print_text, Event, 'Total Score (- [good] to + [bad]) = '+STRING(total_metric_score,$
					format='(I3)')
		;
		if(total_metric_score le 0) then begin
			clr_t = 'green'
			class = -1
			str = 'good'
		endif
		if(total_metric_score gt 0) then begin
			clr_t = 'yellow'
			class = 0
			str = 'maybe'
		endif
		if(total_metric_score ge 2) then begin
			clr_t = 'red'
			class = +1
			str = 'bad'
		endif
		;
		metric_score[7,ifile] = class
		;
		print_text, Event,'Final Classification = '+str
		print_text, Event, ' '
		;
		;	save classification
		;
		(*s_ptr).Classifications[ifile] = class		; for now
		;
		;
		;	BB plot - color of final classification
		;
		EB_led_stack, (*w_ptr).Plot_BB_wid, [clr_t]
		;
		;	put up question pop-up
		;

		;
		if((*w_ptr).Plot_wait_checkbox_value eq 1) then begin
			;
			yn = DIALOG_MESSAGE(['Next Field (Y), or','Stop (N)'],/question)
			;
			if(yn ne 'Yes') then goto, quick_end
			;
		endif
	endfor
	;
	;	all files evaluated, save results
	;
	total_good = 0L
	total_maybe = 0L
	total_bad = 0L
	;
	if(nfiles gt 1) then begin
		outfile = dialog_pickfile(Title='File to save PT ratios into')
		openw, lu_out, outfile, /get_lun
		;
		printf, lu_out, '; N      GP#    date.im0   seeing  Fol.Quar.    Fol. P/T    Slope[P(r)]  P(r) O/I     GPA P/T    GPA Pk%   NESW dPA  Tot.Scor Class'
		for i = 0, nfiles-1 do begin
			printf, lu_out, i+1, file_basename(files[i],"_POLCAT.dat"),$
				date_im0[i],seeing[i],$
				metric_value[0,i],metric_score[0,i],$
				metric_value[1,i],metric_score[1,i],metric_value[2,i],metric_score[2,i],$
				metric_value[3,i],metric_score[3,i],metric_value[4,i],metric_score[4,i],$
				metric_value[5,i],metric_score[5,i],metric_value[6,i],metric_score[6,i],$
				metric_value[7,i],metric_score[7,i],$
				format='(i4.4,1x,a8,1x,a13,1x,f5.3,1x,8(f8.3,1x,i2,1x))'
				;
				case metric_score[7,i] of
					-1: total_good++
					 0: total_maybe++
					+1: total_bad++
				endcase
		endfor
		;
		printf,lu_out,'------------------------------------------------------------------'
		printf,lu_out,'Total Good, Maybe, Bad = ',total_good,total_maybe,total_bad
		free_lun, lu_out
		;
		print_text, Event, 'Total Good, Maybe, Bad = '+STRING(total_good,total_maybe,total_bad,$
			format='(I4,1x,i4,1x,i4)')
	endif
	;
	quick_end:
	;
end