pro dpc_rot
;
;	gets rotation, plate scale terms for a bunch of step 3 images
;
;	DPC	20160925 to test for rotation of images
;
files = dialog_pickfile(title='select FITS images',/MULTIPLE)
nf = N_ELEMENTS(files)
;
angles = fltarr(nf)
xplates = fltarr(nf)
yplates = fltarr(nf)
;
for i = 0, nf-1 do begin
	image = readfits(files[i],header)
	getrot, header, rot, cdelt
	;
	angles[i] = rot * 60.0			; in to arcmin
	xplates[i] = cdelt[0] * 3600.0	; into arcsec per pixel
	yplates[i] = cdelt[1] * 3600.0
	;
endfor
;
histo_a = histogram(angles,nbins=11,locations=x_a)
histo_x = histogram(xplates,nbins=11,locations=x_x)
histo_y = histogram(yplates,nbins=11,locations=x_y)
;
zz_a = median_filtered_mean(angles)
zz_x = median_filtered_mean(xplates)
zz_y = median_filtered_mean(yplates)
;
print, 'Rotation angle mean, uncert = ',zz_a[0],zz_a[1],' arcmin E of N'
print, 'X plate scale mean, uncert  = ',zz_x[0],zz_x[1],' arcsec/pix'
print, 'Y plate scale mean, uncert  = ',zz_y[0],zz_y[1],' arcsec/pix'
;
window, 12, title = 'Rotation angles'
plot, x_a, histo_a, psym=10,xtitle='Rotation Angle [arcmin]'
;
window, 13, title='X-Axis Plate Scales'
plot, x_x, histo_x, psym=10,xtitle='X-Axis Plate Scale [arcsec/pix]'
;
window, 14, title='Y-Axis Plate Scales'
plot, x_y, histo_y, psym=10, xtitle='Y-Axis Plate Scale [arcsec/pix]'
;
cursor, xx, yy, /wait
wait, 1
;
wdelete, 12
wdelete, 13
wdelete, 14
;
end