pro measure_HWP_sky_variations
;
;	takes GP number, finds HWP images for it in S7 directory,
;	opens each, measures sky median, returns mean over 16 HWPs
;	rms of values, and fractional ratio of rms to mean
;
;	DPC	20160818	for tracking down fake swirls in GPIPS data
;
read, prompt='GP field number',gpnum
;
CD, CURRENT=this_dir
gpname = STRING(gpnum,format='("GP",i4.4,"_HWP_")')
infiles = FILE_SEARCH(this_dir, gpname+'*.fits',COUNT=count)
if(count eq 0) then begin
	print, 'No files found. Trying I3 names'
	gpname = STRING(gpnum,format='("GP",i3.3,"_HWP_")')
	infiles = FILE_SEARCH(this_dir, gpname+'*.fits',COUNT=count2)
	if(count2 eq 0) then begin
		print, 'Still no files found. Stopping'
		stop
	endif else begin
		count = count2
	endelse
endif
;
print, 'Found ',count,' HWP files'
sky = fltarr(count)
for i = 0, count-1 do begin
	this_image = infiles[i]
	image = readfits(this_image, this_header, /silent)
	;
	vector = image[400:600:10,400:600:10]
	;
	zz = median_filtered_mean(vector)
	print, 'For image ',FILE_BASENAME(this_image,'.fits'),' mean, rms sky = ',zz[0],zz[1]
	;
	sky[i] = zz[0]
endfor
;
moment_sky = MOMENT(sky,sdev=stddev)
;
fract = 100.0 * stddev / moment_sky[0]
;
print, 'Mean, Stdev, fractional ratio [%] = ',moment_sky[0],stddev,fract
;
end

